################################################################################
#
# $Source: /users/studenter/nilss/source/RCS/meet.tcl,v $
# $Header: meet.tcl,v 2.2 96/02/29 13:40:49 nilss Exp $
# $Author: nilss $
# $Date: 96/02/29 13:40:49 $
# Language: Tcl/Tk
# Status: Experimental
#
# (c) Copyright 1994, TACOMA, all rights reserved.
#
################################################################################
proc meet {agent bc {args ""}} {
    upvar $bc loc_bc
    global env
    set flags 0
    set rc 0

    set options [string tolower $args]
    if {[string match *sync* $options]} {
	set flags [expr {$flags|(1<<0)}]
    }
    if {[string match *locl* $options]} {
	set flags [expr {$flags|(1<<1)}]
    }
    if {[string match *nmrg* $options]} {
	set flags [expr {$flags|(1<<2)}]
    }
    if {[string match *ierr* $options]} {
	set flags [expr {$flags|(1<<3)}]
    }
    if {[string match *crpt* $options]} {
	set flags [expr {$flags|(1<<4)}]
    }
    if {[string match *sign* $options]} {
	set flags [expr {$flags|(1<<5)}]
    }
    if {[string match *path* $options]} {
	set flags [expr {$flags|(1<<16)}]
    }
    if {[string match *nlog* $options]} {
	set flags [expr {$flags|(1<<17)}]
    }

    if { ![catch {open "|$env(TACOMAPATH)/bin/tac_meet $agent $flags" r+} pipe] } {
	puts $pipe [archive loc_bc]
	puts $pipe "\x04"
	flush $pipe

	while {[set inl [gets $pipe]]!="\x04"} {
	    append inbc "$inl\n"
	}
	unarchive loc_bc $inbc
	unset inbc
	set rc [catch {close $pipe} rtxt]
    } else {
	folder_store loc_bc STATUS "$agent, $pipe"
	return 4
    }
    return $rc
}

